Attribute VB_Name = "basCstDr"
'=========================================================================
'   ݁`ppAPITv
'-------------------------------------------------------------------------
'   [RRg[] c[o[̃JX^h[
'-------------------------------------------------------------------------
'   [쐬]    2000N0712
'-------------------------------------------------------------------------
'   [NOTES]
'   VB6 Microsoft Common Controls 6.0 (SP4) gpTvłB
'=========================================================================
Option Explicit

'//==================== WIN32 API ========================================

Public Const WM_NOTIFY = &H4E
Public Const GWL_WNDPROC = -4
Public Const GWL_STYLE = (-16)

Public Type NMHDR
    hwndFrom    As Long
    idfrom      As Long
    code        As Long
End Type

Public Type RECT
    Left        As Long
    Top         As Long
    Right       As Long
    Bottom      As Long
End Type

Public Type POINTAPI
    x           As Long
    y           As Long
End Type

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function DefWindowProc Lib "user32" Alias "DefWindowProcA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Public Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" (ByVal hwndParent As Long, ByVal hwndChildAfter As Long, ByVal lpszClass As String, ByVal lpszWindow As String) As Long
Public Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long

'//==================== COMMON CONTROLS API ===================================

Public Const NM_FIRST = 0&
Public Const NM_CUSTOMDRAW = (NM_FIRST - 12)

Public Const TOOLBARCLASSNAME = "ToolbarWindow32"
Public Const VB6TOOLBARCLASSNAME = "msvb_lib_toolbar"

Public Const TBN_FIRST = -700

Public Const TBSTYLE_FLAT = &H800
Public Const TBSTYLE_LIST = &H1000
Public Const TBSTYLE_CUSTOMERASE = &H2000

Public Type TBBUTTONITEM
    iBitmap     As Long
    idCommand   As Long
    fsState     As Byte
    fsStyle     As Byte
    bReserved(2)    As Byte     '// padding for alignment
    dwData      As Long
    iString     As Long
End Type

Public Type NMTOOLBAR
    hdr         As NMHDR
    iItem       As Long
    TBBUTTON    As TBBUTTONITEM
    cchText     As Long
    pszText     As Long
    rcButton    As Long         '// IE>=5.0
End Type

'//==================== CUSTOM DRAW ==========================================

'// custom draw return flags
'// values under =&H00010000 are reserved for global custom draw values.
'// above that are for specific controls
Public Const CDRF_DODEFAULT = &H0
Public Const CDRF_NEWFONT = &H2
Public Const CDRF_SKIPDEFAULT = &H4

Public Const CDRF_NOTIFYPOSTPAINT = &H10
Public Const CDRF_NOTIFYITEMDRAW = &H20
Public Const CDRF_NOTIFYSUBITEMDRAW = &H20         '// flags are the same, we can distinguish by context
Public Const CDRF_NOTIFYPOSTERASE = &H40

'// drawstage flags
'// values under =&H00010000 are reserved for global custom draw values.
'// above that are for specific controls
Public Const CDDS_PREPAINT = &H1
Public Const CDDS_POSTPAINT = &H2
Public Const CDDS_PREERASE = &H3
Public Const CDDS_POSTERASE = &H4
'// the =&H000010000 bit means it's individual item specific
Public Const CDDS_ITEM = &H10000
Public Const CDDS_ITEMPREPAINT = (CDDS_ITEM Or CDDS_PREPAINT)
Public Const CDDS_ITEMPOSTPAINT = (CDDS_ITEM Or CDDS_POSTPAINT)
Public Const CDDS_ITEMPREERASE = (CDDS_ITEM Or CDDS_PREERASE)
Public Const CDDS_ITEMPOSTERASE = (CDDS_ITEM Or CDDS_POSTERASE)
Public Const CDDS_SUBITEM = &H20000

'// itemState flags
Public Const CDIS_SELECTED = &H1
Public Const CDIS_GRAYED = &H2
Public Const CDIS_DISABLED = &H4
Public Const CDIS_CHECKED = &H8
Public Const CDIS_FOCUS = &H10
Public Const CDIS_DEFAULT = &H20
Public Const CDIS_HOT = &H40
Public Const CDIS_MARKED = &H80
Public Const CDIS_INDETERMINATE = &H100

Public Type NMCUSTOMDRAWINFO
    hdr         As NMHDR
    dwDrawStage As Long
    hdc         As Long
    rc          As RECT
    dwItemSpec  As Long
    uItemState  As Long
    lItemlParam As Long
End Type

Public Type NMTBCUSTOMDRAW
    nmcd                    As NMCUSTOMDRAWINFO
    hbrMonoDither           As Long
    hbrLines                As Long '// For drawing lines on buttons
    hpenLines               As Long '// For drawing lines on buttons
    clrText                 As Long '// Color of text
    clrMark                 As Long '// Color of text bk when marked. (only if TBSTATE_MARKED)
    clrTextHighlight        As Long '// Color of text when highlighted
    clrBtnFace              As Long '// Background of the button
    clrBtnHighlight         As Long '// 3D highlight
    clrHighlightHotTrack    As Long '// In conjunction with fHighlightHotTrack
                                    '// will cause button to highlight like a menu
    rcText                  As RECT '// Rect for text
    nStringBkMode           As Long
    nHLStringBkMode         As Long
End Type

Public hToolBar As Long

Private lpProcOrg   As Long

Public Function WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    
    Dim udtNMHdr    As NMHDR
    Dim udtNMTbr    As NMTOOLBAR
    Dim udtCdTbr    As NMTBCUSTOMDRAW
    Dim blnNoCall   As Boolean
    Dim lngForeColor    As Long
    Dim lngBackColor    As Long
    Dim udtRect     As RECT
    Dim udtTBBtn    As TBBUTTONITEM
    Dim hbr         As Long
    
    Select Case uMsg
        
    Case WM_NOTIFY
        
        CopyMemory udtNMHdr, ByVal lParam, LenB(udtNMHdr)
        
        If udtNMHdr.hwndFrom = hToolBar Then
            
            CopyMemory udtNMTbr, ByVal lParam, LenB(udtNMTbr)
            
            If udtNMTbr.hdr.code = NM_CUSTOMDRAW Then
                
                CopyMemory udtCdTbr, ByVal lParam, LenB(udtCdTbr)
                
                Select Case udtCdTbr.nmcd.dwDrawStage
                '-- Gloval Values
                Case CDDS_POSTERASE     ' After the erasing cycle is complete.
                    WindowProc = CDRF_DODEFAULT
                Case CDDS_POSTPAINT     ' After the painting cycle is complete.
                    WindowProc = CDRF_DODEFAULT
                Case CDDS_PREERASE      ' Before the erasing cycle begins.
                    WindowProc = CDRF_DODEFAULT
                Case CDDS_PREPAINT      ' Before the painting cycle begins.
                    WindowProc = CDRF_NOTIFYITEMDRAW
                '-- Item-specific Values
                Case CDDS_ITEMPREPAINT
                    
                    ' {^̔wiFFƐF݂Ɏw肷B
                    ' {^ꂽꍇ͐ԐF
                    If udtCdTbr.nmcd.uItemState And CDIS_SELECTED Then
                        udtCdTbr.clrBtnFace = RGB(255, 0, 0)
                        udtCdTbr.clrText = vbWhite
                    Else
                        If udtCdTbr.nmcd.dwItemSpec Mod 2 Then
                            udtCdTbr.clrBtnFace = RGB(58, 115, 165)
                            udtCdTbr.clrText = vbWhite
                        Else
                            udtCdTbr.clrBtnFace = RGB(255, 255, 192)
                            udtCdTbr.clrText = vbBlack
                        End If
                    End If
                    
                    ' }EX̓{^̏ʉ߂Ƃ͕FF
                    If udtCdTbr.nmcd.uItemState And CDIS_HOT Then
                        udtCdTbr.clrText = vbBlue
                    End If
                    ' tbgX^CɂꍇALɂă{^̐F
                    ' ύX̂̓ACR̂(oOȂ̂HdlȂ̂H)
                    ' DCgpœhԂ܂B
                    hbr = CreateSolidBrush(udtCdTbr.clrBtnFace)
                    SelectObject udtCdTbr.nmcd.hdc, hbr
                    FillRect udtCdTbr.nmcd.hdc, udtCdTbr.nmcd.rc, hbr
                    DeleteObject hbr
                    
                    ' ύX𔽉f
                    CopyMemory ByVal lParam, udtCdTbr, LenB(udtCdTbr)
                                        
                    WindowProc = CDRF_NOTIFYPOSTPAINT

                Case CDDS_ITEMPOSTPAINT
                    WindowProc = CDRF_DODEFAULT
                                    
                End Select
                
            End If
        End If
    
    Case Else
    
    End Select
    If WindowProc = 0& Then
        WindowProc = CallWindowProc(lpProcOrg, hwnd, uMsg, wParam, lParam)
    End If
    
End Function

Public Sub SubClass(ByVal hwnd As Long)
    lpProcOrg = SetWindowLong(hwnd, GWL_WNDPROC, AddressOf WindowProc)
End Sub

Public Sub UnSubClass(ByVal hwnd As Long)
    Dim lngRet  As Long
    lngRet = SetWindowLong(hwnd, GWL_WNDPROC, lpProcOrg)
End Sub

Public Function LOWORD(dwValue As Long) As Integer
    Dim intVal  As Integer
    CopyMemory intVal, dwValue, 2
    LOWORD = intVal
End Function

Public Function HIWORD(dwValue As Long) As Integer
    Dim intVal  As Integer
    CopyMemory intVal, ByVal VarPtr(dwValue) + 2, 2
    HIWORD = intVal
End Function

Public Function MAKELPARAM(ByVal wLow As Integer, ByVal wHigh As Integer) As Long
    MAKELPARAM = (CLng(wLow) * 2 ^ 16) + CLng(wHigh)
End Function

